/*
 * sos/sossr.c --
 *
 *	There should be a compiler appreciation day. Compile with and
 *	without optimization, look at the generated assembly code,
 *	play with it (e.g., remove the static keywords, what does
 *	change?). See also the corresponding Haskell versions.
 */

#include <stdio.h>
#include <stdlib.h>
#include <inttypes.h>

static uint64_t sos(uint64_t a, uint64_t b)
{
    return (a > b) ? 0 : a*a + sos(a+1, b);
}

int main(int argc, char *argv[])
{
    uint64_t a = 0, b = 4444444;
    
    if (argc == 3) {
	a = strtoll(argv[1], NULL, 10);
	b = strtoll(argv[2], NULL, 10);
    }
    printf("sos %" PRIu64 " %" PRIu64 " = %" PRIu64 "\n", a, b, sos(a, b));
    return EXIT_SUCCESS;
}
